commit 3927bd9f9150576f2905c8930732c419f1850fca
Author: Peter Bergner <bergner@linux.ibm.com>
Date:   Sat Aug 27 19:44:16 2022 -0500

    rs6000: Allow conversions of MMA pointer types [PR106017]
    
    GCC incorrectly disables conversions between MMA pointer types, which
    are allowed with clang.  The original intent was to disable conversions
    between MMA types and other other types, but pointer conversions should
    have been allowed.  The fix is to just remove the MMA pointer conversion
    handling code altogether.
    
    gcc/
            PR target/106017
            * config/rs6000/rs6000.c (rs6000_invalid_conversion): Remove handling
            of MMA pointer conversions.
    
    gcc/testsuite/
            PR target/106017
            * gcc.target/powerpc/pr106017.c: New test.
    
    (cherry picked from commit 1ae1325f24cea1698b56e4299d95446a1f7b90a2)

diff --git a/gcc/config/rs6000/rs6000.c b/gcc/config/rs6000/rs6000.c
index 24696edfb8c..d6be8b7fb6b 100644
--- a/gcc/config/rs6000/rs6000.c
+++ b/gcc/config/rs6000/rs6000.c
@@ -26888,28 +26888,6 @@ rs6000_invalid_conversion (const_tree fromtype, const_tree totype)
       if (tomode == POImode)
 	return N_("invalid conversion to type %<__vector_pair%>");
     }
-  else if (POINTER_TYPE_P (fromtype) && POINTER_TYPE_P (totype))
-    {
-      /* We really care about the modes of the base types.  */
-      frommode = TYPE_MODE (TREE_TYPE (fromtype));
-      tomode = TYPE_MODE (TREE_TYPE (totype));
-
-      /* Do not allow conversions to/from PXImode and POImode pointer
-	 types, except to/from void pointers.  */
-      if (frommode != tomode
-	  && frommode != VOIDmode
-	  && tomode != VOIDmode)
-	{
-	  if (frommode == PXImode)
-	    return N_("invalid conversion from type %<* __vector_quad%>");
-	  if (tomode == PXImode)
-	    return N_("invalid conversion to type %<* __vector_quad%>");
-	  if (frommode == POImode)
-	    return N_("invalid conversion from type %<* __vector_pair%>");
-	  if (tomode == POImode)
-	    return N_("invalid conversion to type %<* __vector_pair%>");
-	}
-    }
 
   /* Conversion allowed.  */
   return NULL;
diff --git a/gcc/testsuite/gcc.target/powerpc/pr106017.c b/gcc/testsuite/gcc.target/powerpc/pr106017.c
new file mode 100644
index 00000000000..46d6c7a4a33
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/pr106017.c
@@ -0,0 +1,19 @@
+/* PR target/106017 */
+/* { dg-options "-O1 -mdejagnu-cpu=power10" } */
+/* { dg-require-effective-target power10_ok } */
+
+/* Make sure we do not flag any errors on the following test cases.  */
+
+void takeacc(__vector_quad *);
+void
+foo (void)
+{
+  __vector_quad arr[4];
+  takeacc (arr);
+}
+
+unsigned char *
+bar (__vector_quad *a)
+{
+  return (unsigned char *)a;
+}

